//+------------------------------------------------------------------+
//| This MQL is generated by Expert Advisor Builder                  |
//|                http://sufx.core.t3-ism.net/ExpertAdvisorBuilder/ |
//|                                                                  |
//|  In no event will author be liable for any damages whatsoever.   |
//|                      Use at your own risk.                       |
//|                                                                  |
//+------------------- DO NOT REMOVE THIS HEADER --------------------+

#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4

#property copyright "Expert Advisor Builder"
#property link      "http://sufx.core.t3-ism.net/ExpertAdvisorBuilder/"

extern int MagicNumber = 789;
extern bool SignalMail = False;
extern bool EachTickMode = False;
extern int  Step = 200;
extern double FactorStep = 1.0;
extern double Lots = 0.1;
extern double FactorLots = 1.0;
extern int MaxOrders = 10;
extern int Slippage = 3;
extern int TakeProfit = 200;
extern bool UseTrailingStop = false;
extern int TrailingStop = 15;
extern int TrailingStopZeroLevel =5;
extern double MMbalancepercent =0;

datetime TimeBar;
int Current;
bool TickCheck = False;
int nAll, nBuy, nSell, nBuyLmt, nSellLmt, LastAll;   double nLots, nCommission, LastCommission;
double Profit;
int Ticket[];
double PositionPrice[], PositionDist[], PositionLots[];
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   TimeBar=Time[0];
   if (EachTickMode) Current = 0; else Current = 1;
   ArrayResize(Ticket, MaxOrders);
   ArrayResize(PositionPrice, MaxOrders);
   ArrayResize(PositionDist, MaxOrders);
   ArrayResize(PositionLots, MaxOrders);
   
   nAll = nBuy = nSell = nBuyLmt = nSellLmt = LastAll = 0;
   nLots = nCommission = LastCommission = 0.0;
   for (int cct = 0; cct<MaxOrders; cct++) Ticket[cct] = -1;
   if(openpos()>0)SetArrays();
   
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   Comment("");
   return(0);
}

//+------------------------------------------------------------------+
//| expert CalculatePosition function                                |
//+------------------------------------------------------------------+
void CalculatePosition(int type)
{
   int i;
   double dir = 1.0;
   double maxLot = MarketInfo(_Symbol,MODE_MAXLOT);
   
   if(type == OP_SELL) dir = -1.0;
   for(i=1; i<MaxOrders; i++)
   {
      PositionDist[i] = PositionDist[i-1] + (double)Step*MathPow(FactorStep,i-1);
      PositionLots[i] = NormalizeDouble((double)Lots*MathPow(FactorLots,i),2);
      if(PositionLots[i] > maxLot) PositionLots[i] = maxLot;
      PositionPrice[i] = NormalizeDouble(PositionPrice[0] - dir*PositionDist[i]*_Point,_Digits);
   }
}

//+------------------------------------------------------------------+
//| expert OpenPosition function                                     |
//+------------------------------------------------------------------+
void OpenPosition(int type)
{
   int i, Type, IdxInit, IdxEnd;
   color clr = DodgerBlue;
   
   if(type == OP_BUY) Type = OP_BUYLIMIT;
                 else Type = OP_SELLLIMIT;
                 
   if(type == OP_SELL) clr = DeepPink;
   
   IdxInit = nAll + nBuyLmt + nSellLmt;
   IdxEnd = IdxInit + (2-(nBuyLmt+nSellLmt));
   for(i=IdxInit; i<=IdxEnd; i++)
   {
      if(i+1>=MaxOrders) continue;
      while(IsTradeContextBusy()) Sleep(1);
      RefreshRates();
      Ticket[i] = OrderSend(_Symbol, Type, PositionLots[i], PositionPrice[i], Slippage, 0, 0, (string)MagicNumber, MagicNumber, 0, clr);
   }
}

//+------------------------------------------------------------------+
//| expert CountOrder function                                       |
//+------------------------------------------------------------------+
void CountOrder()
{
   nAll = nBuy = nSell = nBuyLmt = nSellLmt = 0;
   nLots = Profit = nCommission = 0.0;

   for (int i = 0; i < OrdersTotal(); i++) {
      if(!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
      if(OrderMagicNumber() != MagicNumber) continue;
      if(OrderSymbol() == Symbol()) {
         if(OrderType() == OP_BUY) 
         {
            nAll++;   nBuy++;
            nCommission += OrderSwap() + OrderCommission();
            Profit += OrderProfit() + nCommission;
            nLots += OrderLots();
         } 
         else if(OrderType() == OP_SELL)
         {
            nAll++;   nSell++;
            nCommission += OrderSwap() + OrderCommission();
            Profit += OrderProfit() + nCommission;
            nLots += OrderLots();
         }
         else if(OrderType() == OP_BUYLIMIT) nBuyLmt++;
         else if(OrderType() == OP_SELLLIMIT) nSellLmt++;
      }
   }
}

//+------------------------------------------------------------------+
//| expert CloseAll function                                         |
//+------------------------------------------------------------------+
void CloseAll()
{
   int result;

   LastAll = 0;
   LastCommission = 0.0;
   
   for (int i = OrdersTotal()-1; i >= 0; i--) {
      if(!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
      if(OrderMagicNumber() != MagicNumber) continue;
      if(OrderSymbol() == Symbol()) {
         if(OrderType() == OP_BUY) 
         {
            result = OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,clrGold);
         } 
         else if(OrderType() == OP_SELL)
         {
            result = OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,clrGold);
         }
         else
         {
            result = OrderDelete(OrderTicket(), clrGold);
         }
      }
   }
   
   for (int cct = 0; cct<MaxOrders; cct++) Ticket[cct] = -1;
}

//+------------------------------------------------------------------+
//| expert ChecTicket function                                       |
//+------------------------------------------------------------------+
void CheckTicket()
{
   if(Ticket[0] == -1) return;
   bool slt=OrderSelect(Ticket[0],SELECT_BY_TICKET,MODE_HISTORY);
   datetime dtc1=OrderCloseTime();
   if(dtc1>0) CloseAll();
}

//+------------------------------------------------------------------+
//| expert CalculatePipsCommission function                          |
//+------------------------------------------------------------------+
void CalculatePipsCommission(double& _adjust)
{
   double TickValue = MarketInfo(_Symbol, MODE_TICKVALUE)*nLots;
   
   _adjust = 0.0;
   if(nCommission<0.0) _adjust = NormalizeDouble(MathAbs(nCommission)/TickValue ,0);
}

//+------------------------------------------------------------------+
//| expert RecalculateTakeProfit function                            |
//+------------------------------------------------------------------+
void RecalculateTakeProfit()
{
   int i, result;
   double x1, adjust;
   double tp;
   double dir = 1.0;
   
   CalculatePipsCommission(adjust);
   x1 = TakeProfit*PositionLots[0];
   if(nBuy==0) dir = -1.0;
   for(i = 1; i<nAll; i++) x1 -= PositionLots[i]*PositionDist[i];
   
   x1 = NormalizeDouble(x1/nLots, 0);
   tp = PositionPrice[0] + dir*(x1+adjust)*_Point;
   
   for(i = 0; i<nAll; i++)
   {
      if(!OrderSelect(Ticket[i], SELECT_BY_TICKET, MODE_TRADES)) continue;
      result = OrderModify(OrderTicket(), OrderOpenPrice(), 0, tp, 0, clrNONE);
   }
   LastAll = nAll;
   LastCommission = nCommission;
}
//+------------------------------------------------------------------+
//| expert CheckTrailingStop function                                |
//+------------------------------------------------------------------+
void CheckTrailingStop()
{
   int result, i;
   double dir = 1.0;
   double x1, adjust, price;
   double LevelZero,LevelBE,sl;
   
   if(nBuy == 0) dir = -1.0;
   CalculatePipsCommission(adjust);
   x1 = TrailingStopZeroLevel*PositionLots[0];
   if(nBuy==0) dir = -1.0;
   for(i = 1; i<nAll; i++) x1 -= PositionLots[i]*PositionDist[i];
   
   x1 = NormalizeDouble(x1/nLots, 0);
   LevelZero = PositionPrice[0] + dir*(x1+adjust)*_Point;
   LevelBE = LevelZero + dir*(TrailingStop-TrailingStopZeroLevel)*_Point;
   
   RefreshRates();
   price = (nBuy>0)? Bid:Ask;
   
   if(dir*(price-LevelBE) < 0.0) return;
   if(!OrderSelect(Ticket[0], SELECT_BY_TICKET, MODE_TRADES)) return;
   
   sl = OrderStopLoss();
   if(sl == 0.0) sl = LevelBE;
   else if (dir*(price-sl)>TrailingStop*_Point) sl = price - dir*TrailingStop*_Point;
   
   for (i = 0; i < nAll; i++)
   {
      if(!OrderSelect(Ticket[i], SELECT_BY_TICKET, MODE_TRADES)) continue;
      result=OrderModify(OrderTicket(), OrderOpenPrice(), sl, OrderTakeProfit(), 0, clrNONE);
   }
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   int Order = SIGNAL_NONE;
   double TakeProfitLevel;

   CheckTicket();
   CountOrder();
   if(nAll>0)
   {
      if(UseTrailingStop) CheckTrailingStop();
      if(LastAll<nAll) RecalculateTakeProfit();
      else if(nCommission != LastCommission) RecalculateTakeProfit();
      if(nBuy>0 && nBuyLmt<3)OpenPosition(OP_BUY);
      else if(nSell>0 && nSellLmt<3)OpenPosition(OP_SELL);
   }
   
   
   Comment(" Max N Order: " + (string)MaxOrders + "\n" +
           " Orders All: " + (string)nAll + "\n" +
           " Orders Buy: " + (string)nBuy + "\n" +
           " Orders Sell: " + (string)nSell + "\n" +
           " Profit: " + (string)Profit + "\n" +
           " Commissions: " + (string)nCommission
           );
           
   if (EachTickMode && TimeBar != Time[0]) TickCheck = False;
   Order = SIGNAL_NONE;

   //+------------------------------------------------------------------+
   //| Variable Begin                                                   |
   //+------------------------------------------------------------------+

   double Buy1_1 = iOpen(NULL, 0, Current + 0);
   double Buy1_2 = iMA(NULL, 0, 72, 0, MODE_EMA, PRICE_CLOSE, Current + 0);
   double Buy2_1 = iOsMA(NULL, 0, 21, 36, 9, PRICE_CLOSE, Current + 3);
   double Buy2_2 = iOsMA(NULL, 0, 21, 36, 9, PRICE_CLOSE, Current + 2);
   double Buy3_1 = iOsMA(NULL, 0, 21, 36, 9, PRICE_CLOSE, Current + 0);
   double Buy3_2 = -0.00005;
   double Buy4_1 = iOsMA(NULL, 0, 21, 36, 9, PRICE_CLOSE, Current + 0);
   double Buy4_2 = 0.0003;
   double Buy5_1 = iClose(NULL, 0, Current + 2);
   double Buy5_2 = iOpen(NULL, 0, Current + 0);
   
   double Sell1_1 = iOpen(NULL, 0, Current + 0);
   double Sell1_2 = iMA(NULL, 0, 72, 0, MODE_EMA, PRICE_CLOSE, Current + 0);
   double Sell2_1 = iOsMA(NULL, 0, 21, 36, 9, PRICE_CLOSE, Current + 3);
   double Sell2_2 = iOsMA(NULL, 0, 21, 36, 9, PRICE_CLOSE, Current + 2);
   double Sell3_1 = iOsMA(NULL, 0, 21, 36, 9, PRICE_CLOSE, Current + 0);
   double Sell3_2 = 0.00005;
   double Sell4_1 = iOsMA(NULL, 0, 21, 36, 9, PRICE_CLOSE, Current + 0);
   double Sell4_2 = -0.0003;
   double Sell5_1 = iClose(NULL, 0, Current + 2);
   double Sell5_2 = iOpen(NULL, 0, Current + 0);


   //+------------------------------------------------------------------+
   //| Variable End                                                     |
   //+------------------------------------------------------------------+

   //Check position
   bool IsTrade = False;
   if(nAll>0) IsTrade=true;
   
   //+------------------------------------------------------------------+
   //| Signal Begin(Entry)                                              |
   //+------------------------------------------------------------------+

   if (Buy1_1 < Buy1_2)
   if (Buy2_1 < Buy2_2)
   if (Buy3_1 > Buy3_2)
   if (Buy4_1 < Buy4_2)
   if (Buy5_1 < Buy5_2) Order = SIGNAL_BUY;
   if (Sell1_1 > Sell1_2)
   if (Sell2_1 > Sell2_2)
   if (Sell3_1 < Sell3_2)
   if (Sell4_1 > Sell4_2)
   if (Sell5_1 > Sell5_2) Order = SIGNAL_SELL;
   

   //+------------------------------------------------------------------+
   //| Signal End                                                       |
   //+------------------------------------------------------------------+

   //Buy
   if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (TimeBar != Time[0]))))
   {
      if(!IsTrade)
      {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }
         
         while(IsTradeContextBusy()) Sleep(1);
         RefreshRates();
         
         TakeProfitLevel = Ask + TakeProfit * Point;

         Ticket[0] = OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, 0, TakeProfitLevel, "Buy(#" + MagicNumber + ")", MagicNumber, 0, DodgerBlue);
         if(Ticket[0] > 0)
         {
            if (OrderSelect(Ticket[0], SELECT_BY_TICKET, MODE_TRADES))
            {
               LastAll = 1;
               CountOrder();
               PositionPrice[0] = Ask;   PositionLots[0] = Lots;   PositionDist[0] = 0.0;
               CalculatePosition(OP_BUY);
               OpenPosition(OP_BUY);
               Print("BUY order opened : ", OrderOpenPrice());
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask, Digits) + " Open Buy");
            } 
            else 
            {
               Print("Error opening BUY order : ", GetLastError());
               return(0);
            }
         }
         else return(0);
         if (EachTickMode) TickCheck = True;
      }
   }
   //Sell
   else if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (TimeBar != Time[0]))))
   {
      if(!IsTrade) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }
         
         while(IsTradeContextBusy()) Sleep(1);
         RefreshRates();
         
         TakeProfitLevel = Bid - TakeProfit * Point;

         Ticket[0] = OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, 0, TakeProfitLevel, "Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink);
         if(Ticket[0] > 0)
         {
            if (OrderSelect(Ticket[0], SELECT_BY_TICKET, MODE_TRADES))
            {
               LastAll=1;
               CountOrder();
               PositionPrice[0] = Bid;   PositionLots[0] = Lots;   PositionDist[0] = 0.0;
               CalculatePosition(OP_SELL);
               OpenPosition(OP_SELL);
               Print("SELL order opened : ", OrderOpenPrice());
               if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid, Digits) + " Open Sell");
            }
            else
            {
               Print("Error opening SELL order : ", GetLastError());
               return(0);
            }
         }
         else return(0);
         if (EachTickMode) TickCheck = True;
      }
   }

   if (!EachTickMode) TimeBar = Time[0];

   return(0);
}
//+------------------------------------------------------------------+
int openpos()
{
   int j=0;
   for(int i=0;i<OrdersTotal();i++)
   if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
   if(OrderSymbol()==Symbol()&&OrderType()<=OP_SELL)
   if(OrderMagicNumber()==MagicNumber)   
   j++;
   return(j);
}
void SetArrays()
{
  int first=GetFirst();
  if(first!=0)
  {
    if(OrderSelect(first,SELECT_BY_TICKET))
    {
       string com="Buy(#" + MagicNumber + ")";
       if(OrderType()==OP_SELL) com="Sell(#" + MagicNumber + ")";
       if(OrderComment()==com)
       {
         Ticket[0]=first;
         PositionPrice[0] = OrderOpenPrice();   PositionLots[0] = OrderLots();   PositionDist[0] = 0.0;
         CalculatePosition(OrderType()); 
         for(int i=1;i<MaxOrders;i++)
         Ticket[i]=GetTicket(PositionPrice[i]); 
           
       }
       else CloseAll();  
    }
  }
}
int GetTicket(double price)
{
  int ticket=0;
  for(int i=0;i<OrdersTotal();i++)
  if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
  if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
  {
    if(NormalizeDouble(OrderOpenPrice(),Digits)==NormalizeDouble(price,Digits))ticket=OrderTicket();
  }
  return(ticket);
}
int GetFirst()
{
  int tic=0;
  datetime opt=0;
  for(int i=0;i<OrdersTotal();i++)
  if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
  if(OrderSymbol()==Symbol()&&OrderType()<=OP_SELL&&OrderMagicNumber()==MagicNumber)
  {
    if(opt==0)
    {
      opt=OrderOpenTime();
      tic=OrderTicket();
    }
    else
    {
     if(OrderOpenTime()<opt)
     {
      opt=OrderOpenTime();
      tic=OrderTicket();
     }
    }
  } 
  return(tic);
}
   